<?php

/**
* @author: GavickPro
* @copyright: 2008
**/

/**
	Klasa plugins
	
	Klasa ta odpowiada za kontrolę systemu pluginow
	- instalacje pluginow
	- uruchamianie pluginow
	- wylaczanie pluginow
	- deinstalacje pluginow
	
	Korzysta z dwoch szablonow:
	- plugins.add.php
	- plugins.view.php
	
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

class Plugins{
	
	/*
		Metoda wyswietlajaca liste
		aktualnie dostepnych pluginow
	*/
	
	function viewPlugins(){
		$db =& JFactory::getDBO();

		$query = "SELECT * FROM #__gk_photoslide_plugins ORDER BY id ASC;";
		
		$db->setQuery($query);
		
		$rows = $db->loadObjectList();
		
		require_once(JPATH_COMPONENT.DS.'views'.DS.'admin'.DS.'view.plugin.php');
	}
	
	/*
		Metoda odpowiadajaca za wyswietlenie
		formularza dodawania pluginu
	*/
	
	function addPlugin(){
		require_once(JPATH_COMPONENT.DS.'views'.DS.'admin'.DS.'add.plugin.php');
	}
	
	/*
		Metoda instalujaca plugin
		- umieszcza plik w odpowiednim katalogu
		- wczytuje dane o pluginie z pliku XML
		- umieszcza dane o pluginie w bazie danych
		- modyfikuje strukture bazy danych dodajac nowe pola w tabelach grup i slajdow
	*/
	
	function savePlugin(){
		
		global $mainframe;
		
		// ladowanie podstawowych zmiennych
		$option	= JRequest::getCmd('option');
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		
		// pobranie informacji o wysylanym pliku
		$userfile1 = JRequest::getVar('install_xml', null, 'files', 'array' );
		$userfile2 = JRequest::getVar('install_php', null, 'files', 'array' );

		// Sprawdzenie czy w PHP jest wlaczony upload plikow
		if (!(bool) ini_get('file_uploads')) $mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('Upload file in PHP is disabled !'),'error');

		// Sprawdzenie czy w ogole wybrano jakis plik
		if (!is_array($userfile1) ) $mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('No XML file selected'),'error');
		
		if (!is_array($userfile2) ) $mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('No PHP file selected'),'error');

		// Sprawdzenie czy nie wystapily jakies bledy podczas uploadu
		// oraz czy plik nie jest za duzy
		if ( $userfile1['error'] || $userfile1['size'] < 1 ) $mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('XML file is too big or upload error...'),'error');
		
		if ( $userfile2['error'] || $userfile2['size'] < 1 ) $mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('PHP file is too big or upload error...'),'error');

		// tworzenie odpowiednich sciezek
		$tmp_dest1 = JPATH_COMPONENT.DS.'configuration'.DS.$userfile1['name'];
		$tmp_src1 = $userfile1['tmp_name'];
		
		$tmp_dest2 = JPATH_COMPONENT.DS.'configuration'.DS.$userfile2['name'];
		$tmp_src2 = $userfile2['tmp_name'];

		// przenoszenie pliku do odpowiedniego katalogu
		jimport('joomla.filesystem.file');
		
		// gdy wystapi blad - przekierowanie
		if(!JFile::upload($tmp_src1, $tmp_dest1) || !JFile::upload($tmp_src2, $tmp_dest2)){
			$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JError::raiseWarning('103', 'Error when moving file...'), 'error');
		}else{
			// jezeli nie ma bledu - instaluj
			
			// zaladowanie klasy JURI
			$url = & JURI::getInstance();
		
			// zaladowanie interfejsu baz danych
			$db =& JFactory::getDBO();
			
			// zaladowanie parsera XML
			$xml = & JFactory::getXMLParser('Simple');
			
			// Jezeli plik XML istnieje
			if ($xml->loadFile(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_gk_photoslide'.DS.'configuration'.DS.$userfile1['name'])){
				
				// wczytanie podstawowych danych pliku XML
				$name = & $xml->document->name[0]->data();
				$type = & $xml->document->type[0]->data();
				$version = & $xml->document->version[0]->data();
				$author = & $xml->document->author[0]->data();
				$description = & $xml->document->description[0]->data();
				$filename = $userfile1['name'];
				$phpclassfile = $xml->document->phpclassfile[0]->data();
				
				// przygotowanie podstawowych ciagow pol do dodawnia w bazie danych
				$gfields = '';
				$sfields = '';
				
				// wczytywanie pol bazy danych oraz ich dodawanie
				
				// zmienne list zarezerwowanych pol w bazie danych
				$reserved_gfields = '';
				$reserved_sfields = '';
				// zapytanie MySQL
				$query = 'SELECT gfields,sfields FROM #__gk_photoslide_plugins;';
				// wykonanie zapytania MySQL
				$db->setQuery($query);
				// zaladowanie wynikow zapytania
				$results = $db->loadObjectList();
				// przetworzenie wynikow
				foreach($results as $result){
					$reserved_gfields .= $result->gfields.',';
					$reserved_sfields .= $result->sfields.',';
				}
				
				$reserved_gfields = substr($reserved_gfields,0,(strlen($reserved_gfields)-1));
				$reserved_sfields = substr($reserved_sfields,0,(strlen($reserved_sfields)-1));
				
				// zamiania stringow na tablice
				$reserved_gfields = explode(',',$reserved_gfields);
				$reserved_sfields = explode(',',$reserved_sfields);
				
				// wczytanie pol z pliku XML
				$gfields = '';
				$sfields = '';
				
				$groupdb = & $xml->document->groupdb[0];
				
				if($groupdb){
					for($i = 0; isset($groupdb->field[$i]); $i++){
						$field_name = $groupdb->field[$i]->name[0]->data();
						$field_type = $groupdb->field[$i]->type[0]->data();
						$field_default = $groupdb->field[$i]->default[0]->data();
						
						$gfields .= $field_name.',';
						
						if(!in_array($field_name, $reserved_gfields)){
							$query = "ALTER TABLE #__gk_photoslide_groups ADD `".$field_name."` ".$field_type." NOT NULL DEFAULT ".$field_default.";";
							
							$db->setQuery($query);
							
							if(!$db->query()){
								$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't add new column in database".$query), 'error');	
							}
						}
					}
				}	
				
				$slidedb = & $xml->document->slidedb[0];
				
				if($slidedb){
					for($i = 0; isset($slidedb->field[$i]); $i++){
						$field_name = $slidedb->field[$i]->name[0]->data();
						$field_type = $slidedb->field[$i]->type[0]->data();
						$field_default = $slidedb->field[$i]->default[0]->data();
						
						$sfields .= $field_name.',';
						
						if(!in_array($field_name, $reserved_sfields)){
							$query = "ALTER TABLE #__gk_photoslide_slides ADD `".$field_name."` ".$field_type." NOT NULL DEFAULT ".$field_default.";";
							
							$db->setQuery($query);
							
							if(!$db->query()){
								$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't add new column in database".$query), 'error');	
							}
						}
					}
				}				
				
				$gfields = substr($gfields,0,(strlen($gfields)-1));
				$sfields = substr($sfields,0,(strlen($sfields)-1));
				
				// wczytanie konfiguracji pluginu do bazy danych
				$query = 'INSERT INTO #__gk_photoslide_plugins VALUES(DEFAULT, "'.$name.'", 0, "'.$type.'", "'.$filename.'","'.$phpclassfile.'", "'.$version.'", "'.$author.'","'.$description.'", "'.$gfields.'", "'.$sfields.'");';
				
				$db->setQuery($query);
				
				if(!$db->query()){
					$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't add plugin informations to database"), 'error');	
				}
				
			}else{
				$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't find uploaded XML file"), 'error');	
			}
			
			// Gdy wszystko OK - przekieruj
			$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('File uploaded and installed correctly'));
		}	
	}
	
	/*
		Metoda wlaczajaca dany plugin
	*/
	
	function enablePlugin(){
		global $mainframe;
		
		// inicjalizacja podstawowych zmiennych
		$option	= JRequest::getCmd('option');
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		$db		=& JFactory::getDBO();
		
		// pobranie ID grupy do usuniecia
		$cid    = JRequest::getVar( 'cid', array(0), '', 'array' );
		
		// przygotowanie zapytania MySQL
		$query = 'UPDATE #__gk_photoslide_plugins SET status = 1 WHERE id = '.$cid[0].';';
		
		// wykonanie zapytania MySQL
		$db->setQuery($query);
		$db->query();
		
		// Wykonanie przekierowania wraz z wyświetleniem odpowiedniego komunikatu.
		$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('Plugin has been enabled...'));
	}
	
	/*
		Metoda wylaczajaca dany plugin
	*/
	
	function disablePlugin(){
		global $mainframe;
		
		// inicjalizacja podstawowych zmiennych
		$option	= JRequest::getCmd('option');
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		$db		=& JFactory::getDBO();
		
		// pobranie ID grupy do usuniecia
		$cid    = JRequest::getVar( 'cid', array(0), '', 'array' );
		
		// przygotowanie zapytania MySQL
		$query = 'UPDATE #__gk_photoslide_plugins SET status = 0 WHERE id = '.$cid[0].';';
		
		// wykonanie zapytania MySQL
		$db->setQuery($query);
		$db->query();
		
		// Wykonanie przekierowania wraz z wyświetleniem odpowiedniego komunikatu.
		$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('Plugin has been disabled...'));
	}
	
	/*
		Metoda usuwajaca dany plugin
		- usuwa plik XML pluginu
		- usuwa plik PHP pluginu
		- usuwa pola z bazy danych jezeli nie sa uzywane przez inne pluginy
		- usuwa grupy korzystajace z pluginu
		- usuwa pliki grup korzystajacych z pluginu
	*/
	
	function deletePlugin(){
		global $mainframe;
		
		// inicjalizacja podstawowych zmiennych
		$option	=  JRequest::getCmd('option');
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		$db		=& JFactory::getDBO();
		
		$gfields = '';
		$sfields = '';
		$reserved_gfields = '';
		$reserved_sfields = '';
		
		// pobranie ID grupy do usuniecia
		$cid    = JRequest::getVar( 'cid', array(0), '', 'array' );
		$pid    = $cid[0];
		
		$query = 'SELECT filename, phpclassfile, gfields, sfields FROM #__gk_photoslide_plugins WHERE id = '.$pid.';';
		
		$db->setQuery($query);
		
		if($db->loadObjectList()){
			foreach($db->loadObjectList() as $r){
				$f_xml = $r->filename;
				$f_php = $r->phpclassfile;
				$gfields = $r->gfields;
				$sfields = $r->sfields;
			}
		}else{
			$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't find this plugin in database"), 'error');
		}
		
		$query = 'SELECT gfields, sfields FROM #__gk_photoslide_plugins WHERE id != '.$pid.';';
		
		$db->setQuery($query);
		
		foreach($db->loadObjectList() as $row){
			$reserved_gfields = $row->gfields.',';
			$reserved_sfields = $row->sfields.',';
		}
		
		// zaladowanie systemu plikow Joomla! 1.5
		jimport('joomla.filesystem.file');
		
		// tablica plikow do usuniecia
		$files = array( 
			JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_gk_photoslide'.DS.'configuration'.DS.$f_xml,
			JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_gk_photoslide'.DS.'configuration'.DS.$f_php
		);
		
		// gdy wystapi blad usuwania - przekierowanie
		if(!JFile::delete( $files )){
			$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't remove plugin files"), 'error');
		}else{
			// jezeli nie ma bledu - deinstaluj dalej
			$reserved_gfields = substr($reserved_gfields,0,(strlen($reserved_gfields)-1));
			$reserved_sfields = substr($reserved_sfields,0,(strlen($reserved_sfields)-1));
				
			$t1 = $reserved_gfields;	
			// zamiania stringow na tablice
			$reserved_gfields = explode(',',$reserved_gfields);
			$reserved_sfields = explode(',',$reserved_sfields);
			
			$t2 = $gfields;
			
			// zamiania stringow na tablice
			$gfields = explode(',',$gfields);
			$sfields = explode(',',$sfields);
				
			//if(count($reserved_gfields) > 0){
				for($i = 0; isset($gfields[$i]); $i++){
					if(!in_array($gfields[$i], $reserved_gfields)){
						$query = "ALTER TABLE #__gk_photoslide_groups DROP `".$gfields[$i]."`;";	
						$db->setQuery($query);
							
						if(!$db->query()){
							$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't delete plugin column from database".$query), 'error');	
						}
					}
				}
			//}	
				
			//if(count($reserved_sfields) > 0){
				for($i = 0; isset($sfields[$i]); $i++){
					if(!in_array($sfields[$i], $reserved_sfields)){
						$query = "ALTER TABLE #__gk_photoslide_slides DROP `".$sfields[$i]."`;";	
						$db->setQuery($query);
							
						if(!$db->query()){
							$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't delete plugin column from database".$query), 'error');	
						}
					}
				}
			//}				
			
			// usuwanie powiazanych z pluginem grup i slajdów
			$query = 'SELECT g.id AS id FROM #__gk_photoslide_groups AS g LEFT JOIN #__gk_photoslide_plugins AS p ON g.plugin = p.name WHERE p.id = '.$pid.';';
				
			$db->setQuery($query);
				
			if($db->loadObjectList()){
				foreach($db->loadObjectList as $r){
					require_once(JPATH_COMPONENT.DS.'configuration'.DS.$f_php);
					// obsluga - stworzenie nowej instancji załadowanej klasy
					$pluginClass = new GKPlugin();
					// usuwanie grupy o zadanym id
					$pluginClass->deleteGroup($r->id);	
				}
			}	

			// wczytanie konfiguracji pluginu do bazy danych
			$query = 'DELETE FROM #__gk_photoslide_plugins WHERE id = '.$pid.' LIMIT 1;';
				
			$db->setQuery($query);
				
			if(!$db->query()){
				$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_("Installer cann't delete plugin informations from database"), 'error');	
			}
			
			// Gdy wszystko OK - przekieruj
			// Wykonanie przekierowania wraz z wyświetleniem odpowiedniego komunikatu.
			$mainframe->redirect('index.php?option='.$option.'&client='.$client->id.'&task=view_plugin', JText::_('Plugin and all groups of this plugin has been removed...'));
		}
	}	
}

?>