<?php

/**
* @author: GavickPro
* @copyright: 2008
**/

/**
	Klasa system.control
	
	Klasa ta odpowiada za kontrolę systemu:
	- sprawdzanie uprawnień zapisu w folderach
	- sprawdzanie czy rozszerzenie GD jest aktywne
	- sprawdzanie czy tabele komponentu są załadowane poprawnie
	- wyświetlanie informacji o aktualnej wersji komponentu
	
	ToDo:
	* sprawdzenie czy są dostępne nowe wersje komponentu
	* Statystyki systemu
		* Ilosc grup
		* Ilosc slajdow
		* Ilosc zajetego miejsca w folderach z images i pluginami
		* Ilosc pluginow
	
	EWENTUALNIE MOZNA STATYSTYKI I SPRAWDZANIE NOWEJ WERSJI WRZUCIC JAKO NOWE OPCJE MENU
	
	Korzysta z jednego widoku
	- system.check.php
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

class SystemControl {
	// wersja komponentu
	var $version = '<strong>1.2.0 stable</strong>';
	// status tabeli grup
	var $groupsDB_status = false;
	// status tabeli slajdow
	var	$slidesDB_status = false;
	// status tabeli pluginow
	var	$pluginsDB_status = false;
	// prefiks tabel bazy danych
	var $prefix = '';	
	
	/*
		Metoda sprawdzajaca status rozszerzenia GD.
		Jezeli jest wylaczone to wyswietla napis disabled
		inaczej wyswietla napis enabled.
		
		Nie pobiera zadnych argumentow.
		
		Nie zwraca zadnych wartosci.
	*/
	
	function GDStatus(){
		echo (!extension_loaded('gd')) ? 
		'<strong><font color="red">'.JText::_('Disabled').'</font></strong>':
		'<strong><font color="green">'.JText::_('Enabled').'</font></strong>'; 
	}
	
	/*
		Metoda sprawdzajaca status danego folderu
		jezeli chodzi o zapisywalnosc.
		
		Jako argument pobiera nazwe folderu
		
		Nie zwraca zadnych wartosci.
	*/
	
	function folderStatus($folder){
		if($folder != 'configuration'){
			echo is_writable(JPATH_SITE.DS.'components'.DS.'com_gk_photoslide'.DS.$folder) ? 
			'<strong><font color="green">'. JText::_( 'Writable' ) .'</font></strong>' : 
			'<strong><font color="red">'. JText::_( 'Unwritable' ) .'</font></strong>';
		}else{
			echo is_writable(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_gk_photoslide'.DS.$folder) ?
			'<strong><font color="green">'. JText::_( 'Writable' ) .'</font></strong>' : 
			'<strong><font color="red">'. JText::_( 'Unwritable' ) .'</font></strong>';
		}
	}
	
	/*
		Metoda sprawdzajaca status bazy danych
		pod wzgledem istnienia tabel komponentu w niej.
		
		Ustawia wartosc zmiennych:
			$groupsDB_status, 
			$slidesDB_status, 
			$pluginsDB_status, 
			$prefix
			
		Nie pobiera zadnych argumentow.
		
		Nie zwraca zadnych wartosci.
	*/
	
	function DBStatus(){
		// pobranie listy tabel w bazie danych
		$db =& JFactory::getDBO();
		$results = $db->getTableList();
		// pobranie wartosci prefiksu bazy danych
		$jconf = new JConfig();
		$this->prefix = $jconf->dbprefix;	
		// ustawienie statusow tabel
		for($i=0;$i < count($results);$i++){
			if($results[$i] == $this->prefix.'gk_photoslide_groups') $this->groupsDB_status = true;
			if($results[$i] == $this->prefix.'gk_photoslide_slides') $this->slidesDB_status = true;
			if($results[$i] == $this->prefix.'gk_photoslide_plugins') $this->pluginsDB_status = true;
		}	
	}
	
	/*
		Metoda zwracajaca status istnienia danej tabeli.
		
		Jako argument pobiera nazwe tabeli bez przedrostka.
		
		Nie zwraca zadnych wartosci.
	*/
	
	function DBTableStatus($table){
		// w zaleznosci od tabeli wypisz odpowiedni tekst
		if($table == 'gk_photoslide_groups'){
			echo ($this->groupsDB_status) ? 
			'<strong><font color="green">Yes</font></strong>' : 
			'<strong><font color="red">No</font></strong>';
		}elseif($table == 'gk_photoslide_slides'){
			echo ($this->slidesDB_status) ? 
			'<strong><font color="green">Yes</font></strong>' : 
			'<strong><font color="red">No</font></strong>';
		}elseif($table == 'gk_photoslide_plugins'){
			echo ($this->pluginsDB_status) ? 
			'<strong><font color="green">Yes</font></strong>' : 
			'<strong><font color="red">No</font></strong>';
		}
	}
}

?>